# Coffee-Resque

Static file middleware for [Stack][].  It supports HTTP Conditional GET with 
ETags and file modification dates.

## USAGE

You can place the middleware directly in a [Stack][] server:

    http.createServer(require('stack')(
      require('stack.static')(rootPath, {"default": "index.html"}),
      //...
    )).listen(8080);

You can serve a file manually without using Stack too:

    http.createServer(function(req, res) {
      require('stack.static').serve(rootPath + req.url, req, res, 
        function(err) {
          if(err) { ... 404! ... }
        })
    })

You can probably replace the serve() function with your own implementation if
you want to serve files from somewhere else (S3, GridFS, whatevs).

## INSTALL

    npm install simple-mime
    npm install stack.static

## Development

All code is written in Coffee Script and converted to javascript as it's 
published to npm.

For normal development, all you need to be concerned about is testing:

    $ make test

If you need to generate javascript for production purposes and don't want to use npm packages, you can use:

    $ make generate-js
    $ make remove-js

You can also have coffeescript watch the src directory and generate javascript files as they're updated.

    $ make dev

## TODO

[Stack]: https://github.com/creationix/stack